# -*- coding: utf-8 -*-
import os
import xbmc, xbmcaddon, xbmcplugin
import xbmcgui
import sys
import urllib, urllib2
import time
import re
from htmlentitydefs import name2codepoint as n2cp
import httplib
import urlparse
import socket
from urllib2 import Request, URLError, urlopen
from urlparse import parse_qs
from urllib import unquote_plus
from resources import UyduHanetvKodiPrsr

thisPlugin = int(sys.argv[1])
addonId = "plugin.video.UyduHanetv"
dataPath = xbmc.translatePath('special://profile/addon_data/%s' % (addonId))
busystring = xbmc.getLocalizedString(503).encode("utf8")

try:
    from os import path, system
    if not path.exists(dataPath):
        cmd = "mkdir -p " + dataPath
        system(cmd)
except:
    pass
	   
addon = xbmcaddon.Addon(id=addonId)
adultPIN = addon.getSetting("adultPIN")       
adultPINonoff = addon.getSetting( "adultPINonoff" )
serverId = addon.getSetting( "serverId" )
listegorunumu = addon.getSetting( "listegorunumu" )
mac_id = addon.getSetting( "mac" )
s_key = addon.getSetting( "security_key" )

if mac_id == "":
    try:
        from os import path
        if path.exists("/usr/lib/enigma2/python/Plugins/Extensions/KodiLite"):
            try:
                from Components.Network import iNetwork
                ifaces = iNetwork.getConfiguredAdapters()
                mac_id = iNetwork.getAdapterAttribute(ifaces[0], 'mac')
                addon.setSetting('mac', mac_id)
            except:
                pass
        else:
            mac_id = xbmc.getInfoLabel('Network.MacAddress')
            i = 1
            while mac_id == busystring:
                print "while: %s" % i
                i = i+1
                mac_id = xbmc.getInfoLabel('Network.MacAddress') 
                time.sleep(1)
                if i == 10:
                    break
            addon.setSetting('mac', mac_id)	
    except:
        pass
		

mac = mac_id+'_'+UyduHanetvKodiPrsr.VER	
UyduHanetv_PARSER = UyduHanetvKodiPrsr.UyduHanetv_parsers()
TRModules = UyduHanetvKodiPrsr.modules()

if addon.getSetting('serverId') == "true":
    server = 'net'
else:
    server = 'me'
if addon.getSetting('listegorunumu') == "true":
    xbmcplugin.setContent(int(sys.argv[1]), 'movies')
else:
    pass
Host = "http://www.uyduhane.com/uyduhanetv/listem.php?kullanici_id=16&sayfa=anamenu&karistirici=3ac20ed0ae1ea8a0"
		
def Url_Al(url, mac = None):
    sign = '?'
    url = url.strip(' \t\n\r')
    if url.find('?') > -1:
        sign = '&'
    if mac != None:
        security_key = s_key
        security_param = ""
        url = url + sign + 'box_mac=' + mac + '&key=' + security_key
    if url.find('|') > -1:
        parts = url.split('|')
        url = parts[0]
        cookie = parts[1]
        req = urllib2.Request(url, None, {'User-agent': 'Mozilla/5.0 UyduHanetv-10 Kodi',
        'Connection': 'Close',
        'Cookie': cookie})
    else:
        req = urllib2.Request(url, None, {'User-agent': 'Mozilla/5.0 UyduHanetv-10 Kodi',
        'Connection': 'Close'})
    xmlstream = urllib2.urlopen(req).read()
    return xmlstream
	
def Anamenu():
    content = Url_Al(Host, mac)
    start = 0
    i = 0
    while i < 100:
        n1 = content.find("<channel>", start)
        if n1 < 0:
            break
        n2 = content.find("</channel>", start)
        if n2 < 0:
            break
        ch = content[n1:n2]
        regexvideo = '<title>(.*?)</title>.*?description>.*?>(.*?)</description>.*?<playlist_url>(.*?)</playlist_url>'
        match = re.compile(regexvideo,re.DOTALL).findall(ch)
        name = match[0][0]
        name = name.replace("<![CDATA[", "")
        name = name.replace("]]>", "")
        url = match[0][2]
        url = url.replace("<![CDATA[", "")
        url = url.replace("]]>", "")
        pic = ""
        description = match[0][1]
        description = description.replace("]]>", "")
        ListeyeEkle(name, {"name":name, "url":url, "mode":1}, pic, description)
        start = n2+5       
        i = i+1
    xbmcplugin.endOfDirectory(thisPlugin)

def Liste(name, url):
    if "/aramalar/" in url and 'aramalar_list.php' not in url:
        Ara(url)
    if "TEXT" in name:
        ModuldeAra(url)
    if "HAKKINDA" in name or "%2b18" in name or "erotik" in url or "yetiskin" in url or "Erotik" in url or "Yetiskin" in url:
        if adultPINonoff == "true":			
            if path.exists("/usr/lib/enigma2/python/Plugins/Extensions/KodiLite"):
                pin = adultPIN
                if pin != "1234":
                    return
            else:            
                k = xbmc.Keyboard('', 'PIN i giriniz') ; k.doModal()
                pin = k.getText() if k.isConfirmed() else None
                if pin != adultPIN:
                    return
        if adultPINonoff == "false":
            pass
    else:
        pass
		
    if url.endswith(".m3u") or "type=m3u" in url:
        content = Url_Al(url, mac)
        regexcat = 'EXTINF.*?,(.*?)\\n(.*?)\\n'
        match = re.compile(regexcat,re.DOTALL).findall(content)
        for name, url in match:
            name = name.replace("\n", "")
            name = name.replace("\r", "")
            url = url.replace(" ", "")
            url = url.replace("\n", "")
            url = url.replace("\r", "")
            pic = ""
            ListeyeEkle(name, {"name":name, "url":url, "mode":3}, pic)
        xbmcplugin.endOfDirectory(thisPlugin)
		
    if "TRModules" in url:
        try:
            url = url.replace('TRModules@', '')
            iptv_list_temp = TRModules.get_list(url)
            next_page_url = TRModules.next_page_url
            next_page_text = TRModules.next_page_text
            prev_page_url = TRModules.prev_page_url
            prev_page_text = TRModules.prev_page_text
            search_text = TRModules.search_text
            search_on = TRModules.search_on
            playlistname = TRModules.playlistname
            content = iptv_list_temp
            if "@start" in url or "@category" in url or "@film" in url: 
                for trm in range(len(content)): 
                    name_s = content[trm][1]
                    url_s = content[trm][5]
                    if content[trm][7] == None:
                        pic = ''
                    else:
                        pic = content[trm][7]
                    if content[trm][2] == None:
                        description = ''
                    else:
                        description = content[trm][2]
                    ListeyeEkle(name_s, {"name":name_s, "url":url_s, "mode":1}, pic, description)
            if "@parts" in url: 
                for trm in range(len(content)): 
                    name_p = content[trm][1]
                    url_p = content[trm][4]
                    if content[trm][7] == None:
                        pic = ''
                    else:
                        pic = content[trm][7]
                    if content[trm][2] == None:
                        description = ''
                    else:
                        description = content[trm][2]
                    ListeyeEkle(name_p, {"name":name_p, "url":url_p, "mode":2}, pic, description)
                xbmcplugin.endOfDirectory(thisPlugin)
            if next_page_url :
                name_n = "Next page..."
                nex_url = next_page_url
                pic = ""
                ListeyeEkle(name_n, {"name":name_n, "url":nex_url, "mode":1}, pic)		
            xbmcplugin.endOfDirectory(thisPlugin)
        except:
            pass
    else:
        if "LOKAL" in name:
            try:
                try:
                    lokal = os.path.join(os.path.join("/usr/lib/enigma2/python/Plugins/Extensions/KodiLite"), 'UyduHanetvLokal.xml' )
                    url = lokal
                    f = open(url,'r')
                    data2 = f.read().replace("\n\n", "")
                    f.close()
                    content = data2
                except:
                    lokal = os.path.join(os.path.join(dataPath), 'UyduHanetvLokal.xml' )
                    url = lokal
                    f = open(url,'r')
                    data2 = f.read().replace("\n\n", "")
                    f.close()
                    content = data2
            except:
                url = 'http://UyduHanetv.me/10/UyduHanetvLokal.xml'
                content = Url_Al(url, mac)
        else:
            content = Url_Al(url, mac)
        start = 0
        i = 0
        while i < 10000:
            n1 = content.find("<channel>", start)
            if n1 < 0:
                break
            n2 = content.find("</channel>", start)
            if n2 < 0:
                break
            ch = content[n1:n2]
                    
            if "<stream_url>" in ch: 
                name = re.findall('<title>(.*?)</title>', ch, re.IGNORECASE)[0]
                url = re.findall('<stream_url>(.*?)</stream_url>', ch, re.IGNORECASE)[0]
                try:
                    pic = re.findall('<description><\!\[CDATA\[<img src=[\'|"](.*?)[\'|"]', ch, re.IGNORECASE)[0]
                except:
                    pic = ''
                try:
                    description = re.findall('<description><\!\[CDATA\[<img src=[\'|"].*?[\'|"].*?>(.*?)</description>', ch, re.IGNORECASE)[0]
                except:
                    description = ''
                name = name.replace("<![CDATA[", "")
                name = name.replace("]]>", "")
                name = name.replace("\n", "")
                name = name.replace("\r", "")
                url = url.replace("<![CDATA[", "")
                url = url.replace("]]>", "")
                url = url.replace("UyduHanetvModul@", "")
                url = url.replace("@m3u@UyduHanetv", "")
                description = description.replace("]]>", "")			
                ListeyeEkle(name, {"name":name, "url":url, "mode":2}, pic, description)
                            
            elif "<playlist_url>" in ch: 
                name = re.findall('<title>(.*?)</title>', ch, re.IGNORECASE)[0]
                url = re.findall('<playlist_url>(.*?)</playlist_url>', ch, re.IGNORECASE)[0]
                try:
                    pic = re.findall('<description><\!\[CDATA\[<img src=[\'|"](.*?)[\'|"]', ch, re.IGNORECASE)[0]
                except:
                    pic = ''
                try:
                    description = re.findall('<description><\!\[CDATA\[<img src=[\'|"].*?[\'|"].*?>(.*?)</description>', ch, re.IGNORECASE)[0]
                except:
                    description = ''
                name = name.replace("<![CDATA[", "")
                name = name.replace("]]>", "")
                name = name.replace("\n", "")
                name = name.replace("\r", "")
                url = url.replace("<![CDATA[", "")
                url = url.replace("]]>", "")
                url = url.replace("UyduHanetvModul@", "")
                url = url.replace("@m3u@UyduHanetv", "")
                description = description.replace("]]>", "")			
                ListeyeEkle(name, {"name":name, "url":url, "mode":1}, pic, description)
            else:
                pass
            start = n2+5       
            i = i+1
        if "<next_page_url" in content:
            regexvideo = '<next_page_url.*?http(.*?)\]'
            match = re.compile(regexvideo,re.DOTALL).findall(content)
            name = "Next page..."
            url = "http" + match[0]
            pic = ""
            ListeyeEkle(name, {"name":name, "url":url, "mode":1}, pic)
        xbmcplugin.endOfDirectory(thisPlugin)

def Ara(url):
    k = xbmc.Keyboard('', 'Search') ; k.doModal()
    query = k.getText() if k.isConfirmed() else None
    url = url + "?search=" + query.replace(' ','+')
    name = query
    pic = ""
    ListeyeEkle(name, {"name":name, "url":url, "mode":4}, pic)
    xbmcplugin.endOfDirectory(thisPlugin)

def ModuldeAra(url):
    k = xbmc.Keyboard('', 'Search') ; k.doModal()
    query = k.getText() if k.isConfirmed() else None
    site = re.findall('site=(.*?)$', url, re.IGNORECASE)[0]	
    url = "http://UyduHanetv.me/10/aramalar/moduldeara.php?site="+site+"&search=" + query.replace(' ','+')
    name = query
    pic = ""
    ListeyeEkle(name, {"name":name, "url":url, "mode":4}, pic)
    xbmcplugin.endOfDirectory(thisPlugin)
	
def Aramasonucu(name1, url):
    content = Url_Al(url, mac)
    start = 0
    i = 0
    while i < 1000:
        n1 = content.find("<channel>", start)
        if n1 < 0:
              break
        n2 = content.find("</channel>", start)
        if n2 < 0:
              break
        ch = content[n1:n2]
        if "<stream_url>" in ch: 
            name = re.findall('<title>(.*?)</title>', ch, re.IGNORECASE)[0]
            url = re.findall('<stream_url>(.*?)</stream_url>', ch, re.IGNORECASE)[0]
            try:
                pic = re.findall('<description><\!\[CDATA\[<img src=[\'|"](.*?)[\'|"]', ch, re.IGNORECASE)[0]
            except:
                pic = ''
            try:
                description = re.findall('<description><\!\[CDATA\[<img src=[\'|"].*?[\'|"].*?>(.*?)</description>', ch, re.IGNORECASE)[0]
            except:
                description = ''
            name = name.replace("<![CDATA[", "")
            name = name.replace("]]>", "")
            name = name.replace("\n", "")
            name = name.replace("\r", "")
            url = url.replace("<![CDATA[", "")
            url = url.replace("]]>", "")
            url = url.replace("UyduHanetvModul@", "")
            url = url.replace("@m3u@UyduHanetv", "")
            description = description.replace("]]>", "")			
            ListeyeEkle(name, {"name":name, "url":url, "mode":2}, pic, description)
			
        elif "<playlist_url>" in ch: 
            name = re.findall('<title>(.*?)</title>', ch, re.IGNORECASE)[0]
            url = re.findall('<playlist_url>(.*?)</playlist_url>', ch, re.IGNORECASE)[0]
            try:
                pic = re.findall('<description><\!\[CDATA\[<img src=[\'|"](.*?)[\'|"]', ch, re.IGNORECASE)[0]
            except:
                pic = ''
            try:
                description = re.findall('<description><\!\[CDATA\[<img src=[\'|"].*?[\'|"].*?>(.*?)</description>', ch, re.IGNORECASE)[0]
            except:
                description = ''
            name = name.replace("<![CDATA[", "")
            name = name.replace("]]>", "")
            name = name.replace("\n", "")
            name = name.replace("\r", "")
            url = url.replace("<![CDATA[", "")
            url = url.replace("]]>", "")
            url = url.replace("UyduHanetvModul@", "")
            url = url.replace("@m3u@UyduHanetv", "")
            description = description.replace("]]>", "")			
            ListeyeEkle(name, {"name":name, "url":url, "mode":1}, pic, description)
        else:
            pass				   
        start = n2+5       
        i = i+1
    if "<next_page_url" in content:
        regexvideo = '<next_page_url.*?http(.*?)\]'
        match = re.compile(regexvideo,re.DOTALL).findall(content)
        name = "Next page..."
        url = "http" + match[0]
        pic = ""
        ListeyeEkle(name, {"name":name, "url":url, "mode":4}, pic)
    xbmcplugin.endOfDirectory(thisPlugin)

def VideoListe(name, url):
    play_url = UyduHanetv_PARSER.get_parsed_link(url)
    if (play_url == []) or (play_url == ""):
        play_url = url
        Oynat(name, url)
    else:
        if type(play_url) == str:
            url = play_url
            Oynat(name, url)
        elif type(play_url) == tuple:
            names = []
            urls = []
            names = play_url[2]
            urls = play_url[1]
            if names == []:
                pic = ""
                url = url
                name = name
                Oynat(name, url)
            else:       
                i = 0
                for name in names:
                    pic = ""
                    url = urls[i]
                    i = i+1
                    ListeyeEkle(name, {"name":name, "url":url, "mode":3}, pic)
                xbmcplugin.endOfDirectory(thisPlugin)  

def Oynat(name, url):
    url = url.replace('#', '|')
    if path.exists("/usr/lib/enigma2/python/Plugins/Extensions/KodiLite"): # enigma2 Kodidirect
        pic = "DefaultFolder.png"
        li = xbmcgui.ListItem(name,iconImage="DefaultFolder.png", thumbnailImage=pic)
        player = xbmc.Player()
        player.play(url, li)
    else:
        if ".ts" in url: 
            import F4mProxy
            from F4mProxy import f4mProxyHelper
            player=f4mProxyHelper()
            player.playF4mLink(url, name, streamtype='TSDOWNLOADER')
        else:
            pic = "DefaultFolder.png"
            li = xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=pic)
            player = xbmc.Player()
            player.play(url, li)

def ListeyeEkle(name, parameters={},pic="", description = ""):
    li = xbmcgui.ListItem(name,iconImage="DefaultFolder.png", thumbnailImage=pic)
    li.setInfo(type = 'video', infoLabels={'plot': description})
    url = sys.argv[0] + '?' + urllib.urlencode(parameters)
    return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=url, listitem=li, isFolder=True)

def Parametreler(parameters):
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

params = Parametreler(sys.argv[2])
name =  str(params.get("name", ""))
url =  str(params.get("url", ""))
url = urllib.unquote(url)
mode =  str(params.get("mode", ""))

if not sys.argv[2]:
    ok = Anamenu()
else:
    if mode == str(1):
        ok = Liste(name, url)
    elif mode == str(2):
        ok = VideoListe(name, url)
    elif mode == str(3):
        ok = Oynat(name, url)
    elif mode == str(4):
        ok = Aramasonucu(name, url)